'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildAll = exports.build = undefined;

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var writeDistFiles = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(component, consumer, bitMap) {
    var componentMap, saveDist, distsFiles;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            componentMap = bitMap.getComponent(component.id);

            component.updateDistsPerConsumerBitJson(consumer, componentMap);
            saveDist = component.dists.map(function (distFile) {
              return distFile.write();
            });
            _context.next = 5;
            return Promise.all(saveDist);

          case 5:
            distsFiles = _context.sent;

            if (!(componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED)) {
              _context.next = 9;
              break;
            }

            _context.next = 9;
            return writeLinksInDist(consumer, component, componentMap, bitMap);

          case 9:
            return _context.abrupt('return', distsFiles);

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function writeDistFiles(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var writeLinksInDist = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(consumer, component, componentMap, bitMap) {
    var dependencies, componentWithDeps, newMainFile;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return consumer.loadComponents(component.dependencies.map(function (dep) {
              return dep.id;
            }));

          case 2:
            dependencies = _context2.sent;
            componentWithDeps = new (_componentDependencies || _load_componentDependencies()).default({ component, dependencies: dependencies.components });
            _context2.next = 6;
            return (0, (_linkGenerator || _load_linkGenerator()).writeDependencyLinks)([componentWithDeps], bitMap, consumer, false);

          case 6:
            newMainFile = (0, (_path || _load_path()).pathNormalizeToLinux)(component.calculateMainDistFile());
            _context2.next = 9;
            return component.updatePackageJsonAttribute(consumer, componentMap.rootDir, 'main', newMainFile);

          case 9:
            return _context2.abrupt('return', (0, (_linkGenerator || _load_linkGenerator()).writeEntryPointsForImportedComponent)(component, bitMap, consumer));

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function writeLinksInDist(_x4, _x5, _x6, _x7) {
    return _ref2.apply(this, arguments);
  };
}();

var build = exports.build = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(id) {
    var bitId, consumer, bitMap, component, result, distFilePaths;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            bitId = (_bitId || _load_bitId()).BitId.parse(id);
            _context3.next = 3;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 3:
            consumer = _context3.sent;
            _context3.next = 6;
            return (_bitMap || _load_bitMap()).default.load(consumer.getPath());

          case 6:
            bitMap = _context3.sent;
            _context3.next = 9;
            return consumer.loadComponent(bitId);

          case 9:
            component = _context3.sent;
            _context3.next = 12;
            return component.build({ scope: consumer.scope, consumer, bitMap });

          case 12:
            result = _context3.sent;

            if (!(result === null)) {
              _context3.next = 15;
              break;
            }

            return _context3.abrupt('return', null);

          case 15:
            _context3.next = 17;
            return writeDistFiles(component, consumer, bitMap);

          case 17:
            distFilePaths = _context3.sent;

            bitMap.addMainDistFileToComponent(component.id, distFilePaths);
            _context3.next = 21;
            return bitMap.write();

          case 21:
            return _context3.abrupt('return', distFilePaths);

          case 22:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function build(_x8) {
    return _ref3.apply(this, arguments);
  };
}();

var buildAllResults = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(components, consumer, bitMap) {
    var _this = this;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            return _context5.abrupt('return', components.map(function () {
              var _ref5 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(component) {
                var result, bitId, buildResults;
                return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.next = 2;
                        return component.build({ scope: consumer.scope, consumer, bitMap });

                      case 2:
                        result = _context4.sent;
                        bitId = new (_bitId || _load_bitId()).BitId({ box: component.box, name: component.name });

                        if (!(result === null)) {
                          _context4.next = 6;
                          break;
                        }

                        return _context4.abrupt('return', { component: bitId.toString(), buildResults: null });

                      case 6:
                        _context4.next = 8;
                        return writeDistFiles(component, consumer, bitMap);

                      case 8:
                        buildResults = _context4.sent;
                        return _context4.abrupt('return', { component: bitId.toString(), buildResults });

                      case 10:
                      case 'end':
                        return _context4.stop();
                    }
                  }
                }, _callee4, _this);
              }));

              return function (_x12) {
                return _ref5.apply(this, arguments);
              };
            }()));

          case 1:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function buildAllResults(_x9, _x10, _x11) {
    return _ref4.apply(this, arguments);
  };
}();

var buildAll = exports.buildAll = function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6() {
    var consumer, bitMap, componentsList, newAndModifiedComponents, buildAllP, allComponents, componentsObj;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return (0, (_consumer || _load_consumer()).loadConsumer)();

          case 2:
            consumer = _context6.sent;
            _context6.next = 5;
            return (_bitMap || _load_bitMap()).default.load(consumer.getPath());

          case 5:
            bitMap = _context6.sent;
            componentsList = new (_componentsList || _load_componentsList()).default(consumer);
            _context6.next = 9;
            return componentsList.newAndModifiedComponents();

          case 9:
            newAndModifiedComponents = _context6.sent;

            if (!(!newAndModifiedComponents || !newAndModifiedComponents.length)) {
              _context6.next = 12;
              break;
            }

            return _context6.abrupt('return', Promise.reject('nothing to build'));

          case 12:
            _context6.next = 14;
            return buildAllResults(newAndModifiedComponents, consumer, bitMap);

          case 14:
            buildAllP = _context6.sent;
            _context6.next = 17;
            return Promise.all(buildAllP);

          case 17:
            allComponents = _context6.sent;
            componentsObj = {};

            allComponents.forEach(function (component) {
              componentsObj[component.component] = component.buildResults;
            });
            _context6.next = 22;
            return bitMap.write();

          case 22:
            return _context6.abrupt('return', componentsObj);

          case 23:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function buildAll() {
    return _ref6.apply(this, arguments);
  };
}();

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../consumer');
}

var _component;

function _load_component() {
  return _component = _interopRequireDefault(require('../../../consumer/component'));
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _bitMap;

function _load_bitMap() {
  return _bitMap = _interopRequireDefault(require('../../../consumer/bit-map'));
}

var _componentsList;

function _load_componentsList() {
  return _componentsList = _interopRequireDefault(require('../../../consumer/component/components-list'));
}

var _componentDependencies;

function _load_componentDependencies() {
  return _componentDependencies = _interopRequireDefault(require('../../../scope/component-dependencies'));
}

var _linkGenerator;

function _load_linkGenerator() {
  return _linkGenerator = require('../../../consumer/component/link-generator');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _path;

function _load_path() {
  return _path = require('../../../utils/path');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }