'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = outputFile;

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function outputFile(file, data) {
  var override = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

  return new Promise(function (resolve, reject) {
    if (!override && (_fsExtra || _load_fsExtra()).default.existsSync(file)) {
      var fileContent = (_fsExtra || _load_fsExtra()).default.readFileSync(file).toString();
      if (!fileContent.includes((_constants || _load_constants()).AUTO_GENERATED_STAMP)) return resolve(file);
    }
    (_fsExtra || _load_fsExtra()).default.outputFile(file, data, function (err) {
      if (err) return reject(err);
      return resolve(file);
    });
  });
}